---
title: mask-origin
slug: Web/CSS/mask-origin
tags:
  - CSS
  - CSS Masking
  - CSS Property
  - Experimental
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>mask-origin</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property sets the origin of a mask.</p>

<pre class="brush:css no-line-numbers notranslate">/* Keyword values */
mask-origin: content-box;
mask-origin: padding-box;
mask-origin: border-box;
mask-origin: margin-box;
mask-origin: fill-box;
mask-origin: stroke-box;
mask-origin: view-box;

/* Multiple values */
mask-origin: padding-box, content-box;
mask-origin: view-box, fill-box, border-box;

/* Non-standard keyword values */
-webkit-mask-origin: content;
-webkit-mask-origin: padding;
-webkit-mask-origin: border;

/* Global values */
mask-origin: inherit;
mask-origin: initial;
mask-origin: unset;
</pre>

<p>For elements rendered as a single box, this property specifies the mask positioning area. In other words, this property specifies the origin position of an image specified by the {{cssxref("mask-image")}} CSS property. For elements rendered as multiple boxes, such as inline boxes on several lines or boxes on several pages, it specifies which boxes {{cssxref("box-decoration-break")}} operates upon to determine the mask positioning area.</p>

<h2 id="Syntax">Syntax</h2>

<p>One or more of the keyword values listed below, separated by commas.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>content-box</code></dt>
 <dd>The position is relative to the content box.</dd>
 <dt><code>padding-box</code></dt>
 <dd>The position is relative to the padding box. For single boxes <code>0 0</code> is the upper left corner of the padding edge, <code>100% 100%</code> is the lower right corner.</dd>
 <dt><code>border-box</code></dt>
 <dd>The position is relative to the border box.</dd>
 <dt><code>margin-box</code></dt>
 <dd>The position is relative to the margin box.</dd>
 <dt><code>fill-box</code></dt>
 <dd>The position is relative to the object bounding box.</dd>
 <dt><code>stroke-box</code></dt>
 <dd>The position is relative to the stroke bounding box.</dd>
 <dt><code>view-box</code></dt>
 <dd>Uses the nearest SVG viewport as reference box. If a {{svgattr("viewBox")}} attribute is specified for the element creating the SVG viewport, the reference box is positioned at the origin of the coordinate system established by the <code>viewBox</code> attribute and the dimension of the reference box is set to the width and height values of the <code>viewBox</code> attribute.</dd>
 <dt><code>content</code> {{non-standard_inline}}</dt>
 <dd>Same as <code>content-box</code>.</dd>
 <dt><code>padding</code> {{non-standard_inline}}</dt>
 <dd>Same as <code>padding-box</code>.</dd>
 <dt><code>border</code> {{non-standard_inline}}</dt>
 <dd>Same as <code>border-box</code>.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_mask_origin_to_border-box">Setting mask origin to border-box</h3>

<h4 id="CSS">CSS</h4>

<pre class="brush: css; highlight[9] notranslate">#masked {
  width: 100px;
  height: 100px;
  margin: 10px;
  border: 10px solid blue;
  background-color: #8cffa0;
  padding: 10px;
  mask-image: url(https://mdn.mozillademos.org/files/12676/star.svg);
  mask-origin: border-box; /* Can be changed in the live sample */
}
</pre>

<div class="hidden">
<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div id="masked"&gt;
&lt;/div&gt;
&lt;select id="origin"&gt;
  &lt;option value="content-box"&gt;content-box&lt;/option&gt;
  &lt;option value="padding-box"&gt;padding-box&lt;/option&gt;
  &lt;option value="border-box" selected&gt;border-box&lt;/option&gt;
  &lt;option value="margin-box"&gt;margin-box&lt;/option&gt;
  &lt;option value="fill-box"&gt;fill-box&lt;/option&gt;
  &lt;option value="stroke-box"&gt;stroke-box&lt;/option&gt;
  &lt;option value="view-box"&gt;view-box&lt;/option&gt;
&lt;/select&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">var origin = document.getElementById("origin");
origin.addEventListener("change", function (evt) {
  document.getElementById("masked").style.maskOrigin = evt.target.value;
});
</pre>
</div>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Setting_mask_origin_to_border-box", 160, 200)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS Masks", "#the-mask-origin", "mask-origin")}}</td>
   <td>{{Spec2("CSS Masks")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.mask-origin")}}</p>

<h2 id="See_also">See also</h2>

<ul>
  <li><a href="https://css-tricks.com/clipping-masking-css/">Clipping and Masking in CSS</a></li>
</ul>
